package edu.washington.cs.atomicdebug.examples;


/**
 * A simple bank account class. Not thread-safe, so there are several ways to
 * find race conditions.
 * 
 * @author Laura Effinger-Dean
 */
public class BankAccount {
	private int balance;

	/**
	 * Initialize the bank account with the given balance.
	 * 
	 * @param balance
	 *            Initial balance.
	 */
	public BankAccount(int balance) {
		this.balance = balance;
	}

	public int balance() {
		return balance;
	}

	public void withdraw(int amount) {
		balance -= amount;
	}

	public void deposit(int amount) {
		balance += amount;
	}

	public void transfer(BankAccount toAccount, int amount) {
		this.withdraw(amount);
		toAccount.deposit(amount);
	}
}
